// Use Promise
import promise from 'promise-super';

// Use Global
import { global } from '@linksmile-vue3-scaff/kit';

// Parts Preset
import { init, ext, applet, permission } from './src';

// Export for Use
export default context => {
  /* No Permission */
  if (!permission) {
    return;
  }

  /**
   * vue-scaff
   * ========== ========== ==========
   */
  return class Scaff {
    // Constructor
    constructor(runtime = () => {}, app = applet) {
      // Bind App on Window
      global.App = global.App || app;

      // Ext App
      ext(
        // Init
        init(app, context),

        // Application
        app,

        // Extensions
        part => app.use(part),

        // Callback
        (packages, next) => {
          // Running
          runtime({ ...packages, app }, next);
        },

        // Next Mount
        () => app.mount(process.env.scaff.conf.main.mount),
      );

      // Sugar
      return new promise(resolve => resolve({ app }));
    }
  };
};

// Export for Uni-App
export const Applet = applet;
