// Use Worker
import * as worker from '../worker';

// Use Foreach
import { def, foreach } from '@linksmile-vue3-scaff/kit';

// Export for Useable
export default ({ resource, registry }, app, extension, runtime, next) => {
  // Get Packages
  const packages = foreach(resource, (origin, key) => {
    // Def Worker
    const walker = def(worker);

    // Get Value
    const value = key in walker ? walker[key](app, resource, registry) : (app.config.globalProperties[key] = origin);

    // Return { Key: Value }
    return { key, value };
  });

  // Runtime
  runtime({ ...packages }, () => {
    // Executions
    foreach(packages, (pkg, key) => (pkg.install ? extension(pkg, key) : pkg));

    // Next Mount
    next();
  });
};
