// Use Vue I18N
import { createI18n } from 'vue-i18n';

// Use Kit
import { extensor, foreach } from '@linksmile-vue3-scaff/kit';

// Export
export default (app, { util, i18n }, registry) => {
  // Return as Extensor
  return extensor(i18n, omni => {
    // Get Target
    const target = createI18n({
      locale: navigator?.language || 'zh-CN',
      messages: foreach(omni, hook => hook(util)),
    });

    // Set Use
    app.use(target);
  });
};
