// Use Vue Router
import { createRouter, createWebHistory, createWebHashHistory, createMemoryHistory } from 'vue-router';

// Use Kit
import { extensor, foreach, hand } from '@linksmile-vue3-scaff/kit';

// Export
export default (app, { util, route }, registry) => {
  /**
   * 特别说明：
   * vue-route 大部分情况仅需对 createRouter 之后的对象做拓展，故目前只考虑在 extension 回到函数中传入此实例
   * ========== ========== ==========
   */

  // Set Routes
  let routes = [].concat(registry.route);

  // Inject Route
  foreach(route, (hook, key) => {
    routes = routes.concat(hook(util, registry.api));
  });

  // Return as Extensor
  return extensor(
    // Before Init
    config => {
      // Extension Configure
      const configure = hand(config, routes, {});

      // Default Mode
      configure.mode = configure.mode || 'history';

      // Tolerna
      configure.base = configure.base || '';

      // Default History
      const history = {
        history: createWebHistory(configure.base),
        hash: createWebHashHistory(configure.base),
        abstract: createMemoryHistory(configure.base),
      }[configure.mode];

      // $route
      return createRouter({
        history,
        routes,
        ...configure,
      });
    },

    // After Init
    omni => {
      // Set Use
      app.use(omni);
    },

    // API for Get
    routes,
  );
};
